<template>
  <div class="product-insights-prices-content">
    <div v-if="regularPrice"
         class="product-insights-row">
      <div class="product-insights-label">{{ $t('Regular price') }}</div>
      <div class="product-insights-value">
        <SfPrice
            class="product-insights-price"
            :regular="formatPrice(regularPrice)"
            :special="formatPrice(specialPrice)"
        />
      </div>
    </div>
    <div v-if="tierPrices && tierPrices.length"
         class="product-insights-row">
      <SwTierPrices :tier-prices="tierPrices" class="product-insights-price"/>
    </div>
  </div>
</template>

<script lang="ts">
import {ref, computed} from "@vue/composition-api";
import {SfPrice} from "@storefront-ui/vue";
import SwTierPrices from "@/components/SwTierPrices.vue"
import {
  getProductTierPrices,
  getProductCalculatedPrice,
  getProductCalculatedListingPrice,
  getProductPriceDiscount,
} from "@shopware-pwa/helpers";
import { usePriceFilter } from "../../../logic/composables/usePriceFilter";

export default {
  name: "InsightsPrices",
  components: {
    SfPrice,
    SwTierPrices,
  },
  props: {
    product: {
      type: [Object,Array,String],
      default: null,
    },
  },
  setup(props, {}) {
    const { formatPrice } = usePriceFilter();

    const product = ref(props.product);

    const tierPrices = computed(() =>
        getProductTierPrices(product.value)
    )

    const specialPrice = computed(() =>
        tierPrices.value.length
            ? undefined
            : getProductPriceDiscount(product.value) &&
            getProductCalculatedPrice(product.value)
    )

    const regularPrice = computed(() =>
        (tierPrices.value.length &&
            tierPrices.value[0] &&
            tierPrices.value[0].unitPrice) ||
        getProductCalculatedListingPrice(product.value)
    )

    return {
      tierPrices,
      specialPrice,
      regularPrice,
      formatPrice
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .product-insights-prices-content {
    .product-insights-price {
      --price-regular-font-size: var(--font-size--sm);
      --price-regular-font-weight: normal;
    }

    .sw-tier-prices,
    ::v-deep .sw-tier-prices {
      margin-top: 0;
    }

    ::v-deep {
      .sf-table__heading,
      .sf-table__row {
        border: none;
        padding: 0;

        &:hover {
          --table-row-box-shadow: none;
        }
      }

      .sf-table__header {
        --table-header-font-size: var(--font-size--sm);
      }

      .sf-table__data {
        --table-data-font-size: var(--font-size--sm);
      }
    }
  }
</style>
